class GarlandOfLights:
    def create(self, H, W, lights):
        ret = [-1] * (H*W)
        used = [False] * (H*W)

        #    0c 1a 
        # 0d 2b 5b 
        # 5b    3d 1b
        # 5d       5a
        # 3c 4a 4b 2c
        
        ret[ 1] =  7
        used[ 7] = True
        ret[ 2] =  6
        used[ 6] = True
        
        ret[ 5] = 14
        used[14] = True
        ret[ 6] = 24
        used[24] = True
        ret[ 7] =  0
        used[ 0] = True
        
        ret[10] = 18
        used[18] = True
        ret[12] = 17
        used[17] = True
        ret[13] = 16
        used[16] = True
        
        ret[15] = 23
        used[23] = True
        ret[18] =  2
        used[ 2] = True
        
        ret[20] =  8
        used[ 8] = True
        ret[21] =  5
        used[ 5] = True
        ret[22] = 19
        used[19] = True
        ret[23] = 15
        used[15] = True
        
        ind = 0
        for i in range(H*W):
            if used[i]:
                continue
            while (ret[ind] != -1):
                ind = ind + 1
            ret[ind] = i
        return ret

# -------8<------- end of solution submitted to the website -------8<-------

import sys
H = int(raw_input())
W = int(raw_input())
lights = []
for i in range(H*W):
    lights.append(raw_input())

gl = GarlandOfLights()
ret = gl.create(H, W, lights)
print len(ret)
for num in ret:
    print num
sys.stdout.flush()
